OPT MODULE
OPT EXPORT
OPT PREPROCESS

/*
 * $VER: bgui/arexx.e 41.10= 28.11.98
 * E Header for the BOOPSI ARexx interface class.
 *
 *= C  Copyright 1998 Manuel Lemos.
 *= C  Copyright 1996-1997 Ian J. Einman.
 *= C  Copyright 1993-1996 Jaba Development.
 *= C  Copyright 1993-1996 Jan van den Baard.
 *= C  Copyright 1998 Dominique Dutoit.
 * All Rights Reserved.
 *
 */

MODULE  'exec/types',
        'exec/memory',
        'dos/dos',
        'dos/rdargs',
        'rexx/storage',
        'rexx/rxslib',
        'rexx/errors',
        'utility/tagitem',
        'intuition/classes',
        'intuition/classusr'

/* Tags */
CONST   AREXX_TB                       = TAG_USER+$30000 

CONST   AREXX_HostName                 = AREXX_TB+1     /* I-G-- */
CONST   AREXX_FileExtension            = AREXX_TB+2     /* I---- */
CONST   AREXX_CommandList              = AREXX_TB+3     /* I---- */
CONST   AREXX_SignalMask               = AREXX_TB+4     /* --G-- */
CONST   AREXX_ErrorCode                = AREXX_TB+5     /* I---- */

/* Methods */
CONST   AREXX_MB                       = $30000 

/* ARexx class event-handler. */
CONST   AREXXM_HANDLE_EVENT            = AREXX_MB+1 

/* Execute a host command. */
CONST   AREXXM_EXECUTE                 = AREXX_MB+2 

OBJECT acmExecute
        methodID:LONG
        commandString:PTR TO CHAR
        rc:LONG
        rc2:LONG
        result:PTR TO CHAR
        io:PTR TO CHAR
ENDOBJECT

/*
**      The routines from the command-list will receive a pointer
**      to this structure.  In this structure are the parsed arguments
**      and storage to put the results of the command.
**/
OBJECT rexxArgs
        argList:PTR TO LONG         /* Result of ReadArgs( . */
        rc:LONG                     /* Primary result. */
        rc2:LONG                    /* Secondary result. */
        result:PTR TO CHAR          /* RESULT variable. */
ENDOBJECT

/*
**      An array of these structures must be passed at object-create time.
**/
OBJECT rexxCommand
        name:PTR TO CHAR          /* Command name. */
        argTemplate:PTR TO CHAR   /* DOS-style argument template. */
        func:PTR TO LONG
ENDOBJECT

/*
**      Possible errors.
**/
CONST   RXERR_NO_COMMAND_LIST           = 1
CONST   RXERR_NO_PORT_NAME              = 2
CONST   RXERR_PORT_ALREADY_EXISTS       = 3
CONST   RXERR_OUT_OF_MEMORY             = 4

/*
 * Backwards compatibility.
 */
CONST   AC_HostName                     = AREXX_HostName
CONST   AC_FileExtention                = AREXX_FileExtension
CONST   AC_CommandList                  = AREXX_CommandList
CONST   AC_ErrorCode                    = AREXX_ErrorCode
CONST   AC_RexxPortMask                 = AREXX_SignalMask
CONST   ACM_HANDLE_EVENT                = AREXXM_HANDLE_EVENT
CONST   ACM_EXECUTE                     = AREXXM_EXECUTE
