OPT MODULE
OPT EXPORT
OPT PREPROCESS

/*
 * $VER: bgui/asl.eh 41.10= 28.11.98
 * Asl requester class structures and constants.
 *
 *= C Copyright 1998 Manuel Lemos.
 *= C Copyright 1996-1997 Ian J. Einman.
 *= C Copyright 1993-1996 Jaba Development.
 *= C Copyright 1993-1996 Jan van den Baard.
 *= C Copyright 1996-1998 Dominique Dutoit.
 * All Rights Reserved.
 *
 */

MODULE  'libraries/asl',
        'libraries/bgui'

/*****************************************************************************
 *
 *      "aslreqclass" - BOOPSI Asl filerequester classes= file, font, screen
 *
 *      Tags: 1941 - 2020               Methods: 701 - 740
 */
CONST   ASLREQ_TAGSTART                = BGUI_TB+1941
CONST   FILEREQ_Drawer                 = BGUI_TB+1941  /* ISG-- */
CONST   FILEREQ_File                   = BGUI_TB+1942  /* ISG-- */
CONST   FILEREQ_Pattern                = BGUI_TB+1943  /* ISG-- */
CONST   FILEREQ_Path                   = BGUI_TB+1944  /* --G-- */
CONST   ASLREQ_Left                    = BGUI_TB+1945  /* --G-- */
CONST   ASLREQ_Top                     = BGUI_TB+1946  /* --G-- */
CONST   ASLREQ_Width                   = BGUI_TB+1947  /* --G-- */
CONST   ASLREQ_Height                  = BGUI_TB+1948  /* --G-- */
CONST   FILEREQ_MultiHook              = BGUI_TB+1949  /* IS--- */  /* V40 */
CONST   ASLREQ_Type                    = BGUI_TB+1950  /* I-G-- */  /* V41 */
CONST   ASLREQ_Requester               = BGUI_TB+1951  /* --G-- */  /* V41 */
CONST   ASLREQ_Bounds                  = BGUI_TB+1952  /* IS--- */  /* V41.8 */

CONST   FONTREQ_TextAttr               = BGUI_TB+1980  /* ISG-- */  /* V41 */
CONST   FONTREQ_Name                   = BGUI_TB+1981  /* ISG-- */  /* V41 */
CONST   FONTREQ_Size                   = BGUI_TB+1982  /* ISG-- */  /* V41 */
CONST   FONTREQ_Style                  = BGUI_TB+1983  /* ISG-- */  /* V41 */
CONST   FONTREQ_Flags                  = BGUI_TB+1984  /* ISG-- */  /* V41 */
CONST   FONTREQ_FrontPen               = BGUI_TB+1985  /* ISG-- */  /* V41 */
CONST   FONTREQ_BackPen                = BGUI_TB+1986  /* ISG-- */  /* V41 */
CONST   FONTREQ_DrawMode               = BGUI_TB+1987  /* ISG-- */  /* V41 */

CONST   SCREENREQ_DisplayID            = BGUI_TB+1990  /* ISG-- */  /* V41 */
CONST   SCREENREQ_DisplayWidth         = BGUI_TB+1991  /* ISG-- */  /* V41 */
CONST   SCREENREQ_DisplayHeight        = BGUI_TB+1992  /* ISG-- */  /* V41 */
CONST   SCREENREQ_DisplayDepth         = BGUI_TB+1993  /* ISG-- */  /* V41 */
CONST   SCREENREQ_OverscanType         = BGUI_TB+1994  /* ISG-- */  /* V41 */
CONST   SCREENREQ_AutoScroll           = BGUI_TB+1995  /* ISG-- */  /* V41 */

/*
 *      In addition to the above defined attributes are all
 *      ASL filerequester attributes ISG-U.
 */

/*
 *      Error codes which the SetAttrs( and DoMethod(
 *      calls can return.
 */
CONST   ASLREQ_OK                       = 0    /* OK. No problems.                 */
CONST   ASLREQ_CANCEL                   = 1    /* The requester was cancelled.     */
CONST   ASLREQ_ERROR_NO_MEM             = 2    /* Out of memory.                   */
CONST   ASLREQ_ERROR_NO_REQ             = 3    /* Unable to allocate a requester.  */

/* New Methods */

CONST   ASLM_DOREQUEST                 = BGUI_MB+701   /* Show Requester.  */
/*
 * The following three methods are only needed by class implementors.
 */
CONST   ASLM_ALLOCREQUEST              = BGUI_MB+702   /* AllocRequester( */
CONST   ASLM_REQUEST                   = BGUI_MB+703   /* Request(        */
CONST   ASLM_FREEREQUEST               = BGUI_MB+704   /* FreeRequester(  */
