OPT MODULE
OPT EXPORT
OPT PREPROCESS

/*
 * $VER: bgui/cx.e 41.10 (28.11.98)
 * Commodity class structures and constants.
 *
 * (C) Copyright 1998 Manuel Lemos.
 * (C) Copyright 1996-1997 Ian J. Einman.
 * (C) Copyright 1993-1996 Jaba Development.
 * (C) Copyright 1993-1996 Jan van den Baard.
 * (C) Copyright 1996-1998 Dominique Dutoit.
 * All Rights Reserved.
 *
 */

MODULE  'libraries/commodities',
        'libraries/bgui'

CONST   COMM_Name               = BGUI_TB+1861,  /* I---- */
        COMM_Title              = BGUI_TB+1862,  /* I---- */
        COMM_Description        = BGUI_TB+1863,  /* I---- */
        COMM_Unique             = BGUI_TB+1864,  /* I---- */
        COMM_Notify             = BGUI_TB+1865,  /* I---- */
        COMM_ShowHide           = BGUI_TB+1866,  /* I---- */
        COMM_Priority           = BGUI_TB+1867,  /* I---- */
        COMM_SigMask            = BGUI_TB+1868,  /* --G-- */
        COMM_ErrorCode          = BGUI_TB+1869,  /* --G-- */

/* New Methods. */
        CM_ADDHOTKEY            = BGUI_MB+661

/* Add a hot-key to the broker. */
OBJECT cmAddHotKey
    methodID:LONG           /* CM_ADDHOTKEY             */
    inputDescription:PTR TO LONG    /* Key input description.   */
    keyID:LONG                      /* Key command ID.      */
    flags:LONG                      /* See below.           */
ENDOBJECT

/* Flags. */
SET     CAHF_DISABLED       /* The key is added but won't work.         */

CONST   CM_REMHOTKEY            = BGUI_MB+662, /* Remove a key.      */
        CM_DISABLEHOTKEY        = BGUI_MB+663, /* Disable a key.     */
        CM_ENABLEHOTKEY         = BGUI_MB+664 /* Enable a key.      */

/* Do a key command. */
OBJECT cmDoKeyCommand
    methodID:LONG   /* See above.               */
    keyID:LONG      /* ID of the key.           */
ENDOBJECT

CONST   CM_ENABLEBROKER         = BGUI_MB+665, /* Enable broker.     */
        CM_DISABLEBROKER        = BGUI_MB+666, /* Disable broker.    */
        CM_MSGINFO              = BGUI_MB+667

/* Obtain info from a CxMsg. */
OBJECT cmMsgInfo
    methodID:LONG           /* CM_MSGINFO               */
    infoType:PTR TO LONG    /* Storage for CxMsgType() result.  */
    infoID:PTR TO LONG      /* Storage for CxMsgID() result.    */
    infoData:PTR TO LONG    /* Storage for CxMsgData() result.  */
ENDOBJECT

/* Possible CM_MSGINFO return codes. */
CONST   CMMI_NOMORE             = -1,   /* No more messages.            */
        CMMI_KILL               = $10000, /* Remove yourself.     V40     */
        CMMI_DISABLE            = $20000, /* You have been disabled.  V40     */
        CMMI_ENABLE             = $30000, /* You have been enabled.   V40     */
        CMMI_UNIQUE             = $40000, /* Unique violation ocured. V40     */
        CMMI_APPEAR             = $50000, /* Show yourself.       V40     */
        CMMI_DISAPPEAR          = $60000 /* Hide yourself.       V40     */

/*
 *  CM_ADDHOTKEY error codes obtainable using
 *  the COMM_ErrorCode attribute.
 */
ENUM    CMERR_OK,               /* OK. No problems.         */
        CMERR_NO_MEMORY,        /* Out of memory.           */
        CMERR_KEYID_IN_USE,     /* Key ID already used.             */
        CMERR_KEY_CREATION,     /* Key creation failure.        */
        CMERR_CXOBJERROR        /* CxObjError() reported failure.   */

