OPT MODULE
OPT EXPORT
OPT PREPROCESS

/*
 * $VER: bgui/image.e 41.10 (28.11.96)
 *
 * Image classes structures and constants.
 *
 * (C) Copyright 1998 Manuel Lemos.
 * (C) Copyright 1996-1997 Ian J. Einman.
 * (C) Copyright 1993-1996 Jaba Development.
 * (C) Copyright 1993-1996 Jan van den Baard.
 * (C) Copyright 1996-1998 Dominique Dutoit.
 * All Rights Reserved.
 *
 */

MODULE  'intuition/imageclass',
        'libraries/bgui',
        'graphics/gfx',
        'graphics/rastport',
        'intuition/screens',
        'intuition/intuition'

/*****************************************************************************
 *
 *  "frameclass" - BOOPSI framing image.
 *
 *  Tags: 1 - 80    Methods: 1 - 40
 */
CONST   FRM_TAGSTART                    = BGUI_TB+1,
        FRM_Type                        = BGUI_TB+1,     /* ISG-- */
        FRM_CustomHook                  = BGUI_TB+2,     /* ISG-- */
        FRM_BackFillHook                = BGUI_TB+3,     /* ISG-- */
        FRM_Title                       = BGUI_TB+4,     /* ISG-- */
        FRM_TextAttr                    = BGUI_TB+5,     /* ISG-- */
        FRM_Flags                       = BGUI_TB+6,     /* ISG-- */
        FRM_FrameWidth                  = BGUI_TB+7,     /* ISG-- */
        FRM_FrameHeight                 = BGUI_TB+8,     /* ISG-- */
        FRM_BackFill                    = BGUI_TB+9,     /* ISG-- */
        FRM_EdgesOnly                   = BGUI_TB+10,    /* ISG-- */
        FRM_Recessed                    = BGUI_TB+11,    /* ISG-- */
        FRM_CenterTitle                 = BGUI_TB+12,    /* ISG-- */
        FRM_HighlightTitle              = BGUI_TB+13,    /* ISG-- */
        FRM_ThinFrame                   = BGUI_TB+14,    /* ISG-- */
        FRM_BackPen                     = BGUI_TB+15,    /* ISG-- */  /* V39 */
        FRM_SelectedBackPen             = BGUI_TB+16,    /* ISG-- */  /* V39 */
        FRM_BackDriPen                  = BGUI_TB+17,    /* ISG-- */  /* V39 */
        FRM_SelectedBackDriPen          = BGUI_TB+18,    /* ISG-- */  /* V39 */
        FRM_TitleLeft                   = BGUI_TB+19,    /* ISG-- */  /* V40 */
        FRM_TitleRight                  = BGUI_TB+20,    /* ISG-- */  /* V40 */
        FRM_BackRasterPen               = BGUI_TB+21,    /* ISG-- */  /* V41 */
        FRM_BackRasterDriPen            = BGUI_TB+22,    /* ISG-- */  /* V41 */
        FRM_SelectedBackRasterPen       = BGUI_TB+23,    /* ISG-- */  /* V41 */
        FRM_SelectedBackRasterDriPen    = BGUI_TB+24,    /* ISG-- */  /* V41 */
        FRM_Template                    = BGUI_TB+25,    /* IS--- */  /* V41 */
        FRM_TitleID                     = BGUI_TB+26,    /* ISG-- */  /* V41 */
        FRM_FillPattern                 = BGUI_TB+27,    /* ISG-- */  /* V41 */
        FRM_SelectedFillPattern         = BGUI_TB+28,    /* ISG-- */  /* V41 */
        FRM_OuterOffsetLeft             = BGUI_TB+31,    /* ISG-- */  /* V41 */
        FRM_OuterOffsetRight            = BGUI_TB+32,    /* ISG-- */  /* V41 */
        FRM_OuterOffsetTop              = BGUI_TB+33,    /* ISG-- */  /* V41 */
        FRM_OuterOffsetBottom           = BGUI_TB+34,    /* ISG-- */  /* V41 */
        FRM_InnerOffsetLeft             = BGUI_TB+35,    /* ISG-- */  /* V41 */
        FRM_InnerOffsetRight            = BGUI_TB+36,    /* ISG-- */  /* V41 */
        FRM_InnerOffsetTop              = BGUI_TB+37,    /* ISG-- */  /* V41 */
        FRM_InnerOffsetBottom           = BGUI_TB+38,    /* ISG-- */  /* V41 */
        FRM_TAGDONE                     = BGUI_TB+80,

/* Back fill types */
        STANDARD_FILL                   = 0,
        SHINE_RASTER                    = 1,
        SHADOW_RASTER                   = 2,
        SHINE_SHADOW_RASTER             = 3,
        FILL_RASTER                     = 4,
        SHINE_FILL_RASTER               = 5,
        SHADOW_FILL_RASTER              = 6,
        SHINE_BLOCK                     = 7,
        SHADOW_BLOCK                    = 8,
        FILL_BLOCK                      = 9,        /* V41 */

/* Flags */
        FRF_EDGES_ONLY                  = 1,
        FRF_RECESSED                    = 2,
        FRF_CENTER_TITLE                = 4,
        FRF_HIGHLIGHT_TITLE             = 8,
        FRF_THIN_FRAME                  = 16,
        FRF_TITLE_LEFT                  = 32,         /* V40 */
        FRF_TITLE_RIGHT                 = 64          /* V40 */

ENUM    FRB_EDGES_ONLY,
        FRB_RECESSED,
        FRB_CENTER_TITLE,
        FRB_HIGHLIGHT_TITLE,
        FRB_THIN_FRAME,
        FRB_TITLE_LEFT,         /* V40 */
        FRB_TITLE_RIGHT         /* V40 */

/* Frame types */
CONST   FRTYPE_CUSTOM                   = 0,
        FRTYPE_BUTTON                   = 1,
        FRTYPE_RIDGE                    = 2,
        FRTYPE_DROPBOX                  = 3,
        FRTYPE_NEXT                     = 4,
        FRTYPE_RADIOBUTTON              = 5,
        FRTYPE_XEN_BUTTON               = 6,
        FRTYPE_TAB_ABOVE                = 7,    /* V40 */
        FRTYPE_TAB_BELOW                = 8,    /* V40 */
        FRTYPE_BORDER                   = 9,    /* V40 */
        FRTYPE_NONE                     = 10,   /* V40 */
        FRTYPE_FUZZ_BUTTON              = 11,   /* V41 */
        FRTYPE_FUZZ_RIDGE               = 12,   /* V41 */
        FRTYPE_TAB_TOP                  = 13,   /* V41.8 */
        FRTYPE_TAB_BOTTOM               = 14,
        FRTYPE_TAB_LEFT                 = 15,
        FRTYPE_TAB_RIGHT                = 16,

        FRTYPE_DEFAULT                  = -1,   /* 41.8 */

        FRAMEM_BACKFILL                 = BGUI_MB+21

/* Backfill a specific rectangle with the backfill hook. */
OBJECT fmBackfill
        methodID:LONG             /* FRM_RENDER                     */
        bInfo:PTR TO baseInfo     /* BaseInfo ready for rendering   */
        bounds:PTR TO rectangle   /* Rendering bounds.              */
        state:LONG                /* See "intuition/imageclass.h"   */
ENDOBJECT

/*
 *  FRM_RENDER:
 *
 *  The message packet sent to both the FRM_CustomHook
 *  and FRM_BackFillHook routines. Note that this
 *  structure is READ-ONLY!
 *
 */
CONST   FRM_RENDER                      = 1 /* Render yourself           */

OBJECT frameDrawMsg
    methodID:LONG               -> FRM_RENDER
    rPort:PTR TO rastport       -> RastPort ready for rendering
    drawInfo:PTR TO drawinfo    -> All you need to render
    bounds:PTR TO rectangle     -> Rendering bounds
    state:INT                   -> See "intuition/imageclass.h"
    horizontal:CHAR             -> Horizontal thickness
    vertical:CHAR               -> Vertical thickness
ENDOBJECT

/*
 *  FRM_THICKNESS:
 *
 *  The message packet sent to the FRM_Custom hook.
 */
CONST   FRM_THICKNESS   = 2 /* Give the default frame thickness. */

OBJECT thicknessMsg
    methodID:LONG                       -> FRM_THICKNESS
    thicknessHorizontal:PTR TO CHAR     -> Storage for horizontal
    thicknessVertical:PTR TO CHAR       -> Storage for vertical
    thin:INT                            -> Added in V38!
ENDOBJECT

/* Possible hook return codes. */
CONST   FRC_OK              = 0,             /* OK        */
        FRC_UNKNOWN         = 1,             /* Unknow method */

/*****************************************************************************
 *
 *  "labelclass" - BOOPSI labeling image.
 *
 *  Tags: 81 - 160      Methods: 1 - 40
 */
        LAB_TAGSTART        = BGUI_TB+81,
        LAB_TextAttr        = BGUI_TB+81,    /* ISG-- */
        LAB_Style           = BGUI_TB+82,    /* ISG-- */
        LAB_Underscore      = BGUI_TB+83,    /* ISG-- */
        LAB_Place           = BGUI_TB+84,    /* ISG-- */
        LAB_Label           = BGUI_TB+85,    /* ISG-- */
        LAB_Flags           = BGUI_TB+86,    /* ISG-- */
        LAB_Highlight       = BGUI_TB+87,    /* ISG-- */
        LAB_HighUScore      = BGUI_TB+88,    /* ISG-- */
        LAB_Pen             = BGUI_TB+89,    /* ISG-- */
        LAB_SelectedPen     = BGUI_TB+90,    /* ISG-- */
        LAB_DriPen          = BGUI_TB+91,    /* ISG-- */
        LAB_SelectedDriPen  = BGUI_TB+92,    /* ISG-- */
        LAB_LabelID         = BGUI_TB+93,    /* ISG-- */ /* V41 */
        LAB_Template        = BGUI_TB+94,    /* IS--- */ /* V41 */
        LAB_NoPlaceIn       = BGUI_TB+95,    /* ISG-- */     /* V41.7 */
        LAB_SelectedStyle   = BGUI_TB+96,    /* ISG-- */     /* V41.7 */
        LAB_FlipX           = BGUI_TB+97,    /* ISG-- */     /* V41.7 */
        LAB_FlipY           = BGUI_TB+98,    /* ISG-- */     /* V41.7 */
        LAB_FlipXY          = BGUI_TB+99,    /* ISG-- */     /* V41.7 */
        LAB_TAGDONE         = BGUI_TB+160,

/* Flags */
        LABF_HIGHLIGHT      = 1, /* Highlight label    */
        LABF_HIGH_USCORE    = 2, /* Highlight underscoring */
        LABF_FLIP_X         = 4, /* Flip across x axis     */
        LABF_FLIP_Y         = 8, /* Flip across y axis     */
        LABF_FLIP_XY        = 16,/* Flip across x = y      */

        LABB_HIGHTLIGHT     = 0, /* Highlight label    */
        LABB_HIGH_USCORE    = 1, /* Highlight underscoring */
        LABB_FLIP_X         = 2, /* Flip across x axis     */
        LABB_FLIP_Y         = 3, /* Flip across y axis     */
        LABB_FLIP_XY        = 4, /* Flip across x = y      */

/* Label placement */
        PLACE_IN            = 0,
        PLACE_LEFT          = 1,
        PLACE_RIGHT         = 2,
        PLACE_ABOVE         = 3,
        PLACE_BELOW         = 4,

/* New methods */
/*
 *  The IM_EXTENT method is used to find out how many
 *  pixels the label extents the relative hitbox in
 *  either direction. Normally this method is called
 *  by the baseclass.
 */
        IM_EXTENT           = BGUI_MB+1

OBJECT impExtent
    methodID:LONG           /* IM_EXTENT            */
    rPort:PTR TO rastport           /* RastPort         */
    extent:PTR TO ibox              /* Storage for extentions.  */
    labelSizeWidth:PTR TO INT       /* Storage width in pixels  */
    labelSizeHeight:PTR TO INT      /* Storage height in pixels */
    flags:INT                       /* See below.           */
ENDOBJECT

CONST   EXTF_MAXIMUM        = 1, /* Request maximum extensions. */

/*****************************************************************************
 *
 *  "vectorclass" - BOOPSI scalable vector image.
 *
 *  Tags: 161 - 240
 *
 *  Based on an idea found in the ObjectiveGadTools.library
 *  by Davide Massarenti.
 */
        VIT_TAGSTART        = BGUI_TB+161,
        VIT_VectorArray     = BGUI_TB+161,   /* ISG-- */
        VIT_BuiltIn         = BGUI_TB+162,   /* ISG-- */
        VIT_Pen             = BGUI_TB+163,   /* ISG-- */
        VIT_DriPen          = BGUI_TB+164,   /* ISG-- */
        VIT_ScaleWidth      = BGUI_TB+165,   /* --G-- */ /* V41 */
        VIT_ScaleHeight     = BGUI_TB+166,   /* --G-- */ /* V41 */
        VIT_TAGDONE         = BGUI_TB+240

/*
 *  Command structure which can contain
 *  coordinates, data and command flags.
 */
OBJECT vectorItem
    x:INT        /* X coordinate or data */
    y:INT        /* Y coordinate         */
    flags:LONG   /* See below        */
ENDOBJECT

/* Flags */
SET     VIF_MOVE,           /* Move to x, y           */
        VIF_DRAW,           /* Draw to x, y           */
        VIF_AREASTART,      /* Start AreaFill at x, y     */
        VIF_AREAEND,        /* End AreaFill at x, y       */
        VIF_XRELRIGHT,      /* x relative to right edge      */
        VIF_YRELBOTTOM,     /* y relative to bottom edge     */
        VIF_SHADOWPEN,      /* switch to SHADOWPEN, Move/Draw   */
        VIF_SHINEPEN,       /* switch to SHINEPEN, Move/Draw    */
        VIF_FILLPEN,        /* switch to FILLPEN, Move/Draw     */
        VIF_TEXTPEN,        /* switch to TEXTPEN, Move/Draw     */
        VIF_COLOR,          /* switch to color in x      */
        VIF_LASTITEM,       /* last element of the element list */
        VIF_SCALE,          /* X & Y are design width & height  */
        VIF_DRIPEN,         /* switch to dripen x        */
        VIF_AOLPEN,         /* set area outline pen x        */
        VIF_AOLDRIPEN,      /* set area outline dripen x     */
        VIF_ENDOPEN,        /* end area outline pen             */
        VIF_MINSIZE,        /* X & Y are minimum size            */  /* V41.8 */
        VIF_LINEPATTERN,    /* Use line pattern in vc_x          */
        VIF_BPEN,           /* Interpret vc_y as bpen            */
        VIF_DRAWMODE        /* Draw mode                         */


/* Built-in images. */
ENUM    BUILTIN_GETPATH = 1,
        BUILTIN_GETFILE,
        BUILTIN_CHECKMARK,
        BUILTIN_POPUP,
        BUILTIN_ARROW_UP,
        BUILTIN_ARROW_DOWN,
        BUILTIN_ARROW_LEFT,
        BUILTIN_ARROW_RIGHT,
        BUILTIN_CYCLE,          /* V41 */
        BUILTIN_CYCLE2,         /* V41 */
        BUILTIN_RADIOBUTTON,    /* V41 */
        BUILTIN_GETFONT,        /* V41.9 */
        BUILTIN_GETSCREEN       /* V41.9 */

/* Design width and heights of the built-in images. */
CONST   GETPATH_WIDTH       = 20,
        GETPATH_HEIGHT      = 14,
        GETFILE_WIDTH       = 20,
        GETFILE_HEIGHT      = 14,
        CHECKMARK_WIDTH     = 24,
        CHECKMARK_HEIGHT    = 11,
        POPUP_WIDTH         = 15,
        POPUP_HEIGHT        = 13,
        ARROW_UP_WIDTH      = 16,
        ARROW_UP_HEIGHT     = 9,
        ARROW_DOWN_WIDTH    = 16,
        ARROW_DOWN_HEIGHT   = 9,
        ARROW_LEFT_WIDTH    = 10,
        ARROW_LEFT_HEIGHT   = 12,
        ARROW_RIGHT_WIDTH   = 10,
        ARROW_RIGHT_HEIGHT  = 12
