OPT MODULE
OPT EXPORT
OPT PREPROCESS

/*
 * $VER: bgui/obsolete.e 41.10 (28.11.98)
 * bgui.library obsolete definitions
 *
 * (C) Copyright 1998 Manuel Lemos.
 * (C) Copyright 1996-1997 Ian J. Einman.
 * (C) Copyright 1993-1996 Jaba Development.
 * (C) Copyright 1993-1996 Jan van den Baard.
 * (C) Copyright 1996-1998 Dominique Dutoit.
 * All Rights Reserved.
 *
 */

MODULE  'libraries/bgui',
        'utility/tagitem',
        'utility/hooks',
        'intuition/classes',
        'intuition/cghooks',
        'graphics/rastport',
		'*bgui_asl'

/* New methods */
CONST   BASE_ADDMAP         = BGUI_MB+41

/* Add an object to the maplist notification list. */
OBJECT bmAddMap
    methodID:LONG
    object:PTR TO object
    mapList:PTR TO tagitem
ENDOBJECT

CONST   BASE_ADDCONDITIONAL     = BGUI_MB+42

/* Add an object to the conditional notification list. */
OBJECT bmAddConditional
    methodID:LONG
    object:PTR TO object
    condition:tagitem
    true:tagitem
    false:tagitem
ENDOBJECT

CONST   BASE_ADDMETHOD          = BGUI_MB+43

/* Add an object to the method notification list. */
OBJECT bmAddMethod
    methodID:LONG
    object:PTR TO object
    flags:LONG
    size:LONG
    amethodID:LONG
ENDOBJECT

SET     BAMF_NO_GINFO,  /* Do not send GadgetInfo. */
        BAMF_NO_INTERIM /* Skip interim messages.  */

CONST   BASE_REMMAP             = BGUI_MB+44,
        BASE_REMCONDITIONAL     = BGUI_MB+45,
        BASE_REMMETHOD          = BGUI_MB+46

/* Remove an object from a notification list. */
OBJECT bmRemove
    methodID:LONG
    object:PTR TO object
ENDOBJECT

CONST   BASE_ADDHOOK            = BGUI_MB+52

/* Add a hook to the hook-notification list. */
OBJECT bmAddHook
    methodID:LONG
    hook:PTR TO hook
ENDOBJECT

/* Remove a hook from the hook-notification list. */
CONST   BASE_REMHOOK            = BGUI_MB+53

CONST   GRM_ADDMEMBER           = BGUI_MB+81

/* Add a member to the group. */
OBJECT grmAddMember
    methodID:LONG           -> GRM_ADDMEMBER
    member:PTR TO object    -> Object to add
    attr:LONG               -> First of LGO attributes
ENDOBJECT

CONST   GRM_REMMEMBER           = BGUI_MB+82

/* Remove a member from the group. */
OBJECT grmRemMember
    methodID:LONG    -> GRM_REMMEMBER
    member:PTR TO object     -> Object to remove
ENDOBJECT

CONST   GRM_DIMENSIONS          = BGUI_MB+83

/* Ask an object it's dimensions information. */
OBJECT grmDimensions
    methodID:LONG               -> GRM_DIMENSIONS
    gInfo:PTR TO gadgetinfo     -> Can be NIL!
    rPort:PTR TO rastport       -> Ready for calculations
    minSizeWidth:PTR TO INT
    minSizeHeight:PTR TO INT
    flags:LONG                  -> See below
ENDOBJECT

/* Flags */
CONST   GDIMF_MAXIMUM          = 8,  /* The grmd_MaxSize is requested.       */
        GDIMF_NOMINAL          = 4,  /* The grmd_NomSize is requested.       */

        GRM_ADDSPACEMEMBER      = BGUI_MB+84

/* Add a weight controlled spacing member. */
OBJECT grmAddSpaceMember
    methodID:LONG       -> GRM_ADDSPACEMEMBER
    weight:LONG         -> Object weight
ENDOBJECT

CONST   GRM_INSERTMEMBER        = BGUI_MB+85

/* Insert a member in the group. */
OBJECT grmInsertMember
    methodID:LONG           -> GRM_INSERTMEMBER
    member:PTR TO object    -> Member to insert
    pred:PTR TO object      -> Insert after this member
    attr:LONG               -> First of LGO attributes
ENDOBJECT

CONST   GRM_REPLACEMEMBER       = BGUI_MB+86    /* V40 */

/* Replace a member in the group. */
OBJECT grmReplaceMember
    methodID:LONG           -> GRM_REPLACEMEMBER
    memberA:PTR TO object   -> Object to replace
    memberB:PTR TO object   -> Object which replaces
    attr:LONG               -> First of LGO attributes
ENDOBJECT

/*
 *      These are required for backwards compatibility with old code.
 *      Use the new identifiers instead.
 */
CONST   FRQ_Left                = ASLREQ_Left
CONST   FRQ_Top                 = ASLREQ_Top
CONST   FRQ_Width               = ASLREQ_Width
CONST   FRQ_Height              = ASLREQ_Height
CONST   FRQ_Drawer              = FILEREQ_Drawer
CONST   FRQ_File                = FILEREQ_File
CONST   FRQ_Pattern             = FILEREQ_Pattern
CONST   FRQ_Path                = FILEREQ_Path
CONST   FRQ_MultiHook           = FILEREQ_MultiHook
CONST   FRQ_OK                  = ASLREQ_OK
CONST   FRQ_CANCEL              = ASLREQ_CANCEL
CONST   FRQ_ERROR_NO_MEM        = ASLREQ_ERROR_NO_MEM
CONST   FRQ_ERROR_NO_FREQ       = ASLREQ_ERROR_NO_REQ
CONST   FRM_DOREQUEST           = ASLM_DOREQUEST
